# Gamerules
gamerule doImmediateRespawn false
gamerule spectatorsGenerateChunks true

# Revive
execute at @e[nbt={Item:{components:{"minecraft:custom_data":{Revive:1}}},PickupDelay:0s}] run tag @p[distance=..2,gamemode=spectator] add Revive
execute at @a[tag=Revive] run kill @e[nbt={Item:{components:{"minecraft:custom_data":{Revive:1}}}},limit=1,distance=..5]
execute at @a[tag=Revive] run gamemode survival @p
execute if score hcr_settings revive_debuffs matches 1 run execute at @a[tag=Revive] run effect give @p minecraft:slowness 60 1 true
execute if score hcr_settings revive_debuffs matches 1 run execute at @a[tag=Revive] run effect give @p minecraft:weakness 60 1 true
execute if score hcr_settings revive_debuffs matches 1 run execute at @a[tag=Revive] run effect give @p minecraft:glowing 60 1 true
execute if score hcr_settings revive_debuffs matches 1 run execute at @a[tag=Revive] run effect give @p minecraft:hunger 60 1 true
execute if score hcr_settings revive_debuffs matches 1 run execute at @a[tag=Revive] run effect give @p minecraft:mining_fatigue 60 1 true
execute if score hcr_settings revive_debuffs matches 1 run execute at @a[tag=Revive] run effect give @p minecraft:poison 2 0 true
execute at @a[tag=Revive] run scoreboard players set @p Lives 2
execute at @a[tag=Revive] run playsound minecraft:ui.toast.challenge_complete master @a ~ ~ ~ 10 1
execute at @a[tag=Revive] if dimension minecraft:overworld run spawnpoint @p
execute at @a[tag=Revive] if dimension minecraft:the_nether run spawnpoint @p

execute at @a[tag=Revive] run tag @p remove Revive

# Detect deaths
execute as @a[scores={deaths=1..}] run function hcrplus:death

# Check for Life Jam uses
execute as @a[scores={lifeReset=1..}] run function hcrplus:life_reset

# Set spawn
execute at @a[scores={health=0,Lives=..0}] if dimension minecraft:overworld run spawnpoint @p ~ ~1 ~
execute at @a[scores={health=0,Lives=..0}] if dimension minecraft:the_nether run spawnpoint @p ~ ~1 ~

# Ghost particles
execute at @a[gamemode=spectator,scores={Lives=..0}] run particle dust{color:[1.000,1.000,1.000],scale:1} ~ ~1.5 ~ 0.5 0.5 0.5 0 2 force

# Scare
execute at @a[gamemode=spectator,scores={Lives=..0}] run tag @e[type=!minecraft:player,distance=..0.8] add Scared
data modify entity @e[tag=Scared,limit=1,nbt=!{TicksFrozen:0}] TicksFrozen set value 140
effect give @e[tag=Scared,nbt=!{active_effects:[{id:"minecraft:wither"}]}] minecraft:wither 3 0 true

tag @e[type=!minecraft:player] remove Scared

# Possess
execute at @a[gamemode=spectator,scores={Lives=..0}] run tag @a[distance=..1,gamemode=survival] add Possessed
effect give @a[tag=Possessed] minecraft:strength 1 0 true
effect give @a[tag=Possessed] minecraft:speed 1 0 true
effect give @a[tag=Possessed] minecraft:resistance 1 0 true
effect give @a[tag=Possessed] minecraft:glowing 1 0 true
tag @a remove Possessed

# Health Debuffs
execute as @a[scores={Lives=2..3}] run attribute @s minecraft:generic.max_health base set 20
execute as @a[scores={Lives=4..}] run attribute @s minecraft:generic.max_health base set 24
execute as @a[scores={Lives=1}] run attribute @s minecraft:generic.max_health base set 16

# Potion buffs
execute as @a[scores={bedrockEssence=1}] run effect give @s resistance infinite 0 false
execute as @a[scores={axolotlBlesing=1}] run effect give @s regeneration infinite 0 false

# Fix scores
scoreboard players set @a[tag=!nHrCheck] Lives 3
scoreboard players set @a[tag=!nHrCheck] bedrockEssence 0
scoreboard players set @a[tag=!nHrCheck] axolotlBlesing 0
scoreboard players set @a nothing 0

# Set team colors
execute if score hcr_settings name_colors matches 1 run team modify 1 color red
execute if score hcr_settings name_colors matches 1 run team modify 2 color yellow
execute if score hcr_settings name_colors matches 1 run team modify 3 color green
execute if score hcr_settings name_colors matches 1 run team modify 4 color aqua

# Set player teams
execute if score hcr_settings name_colors matches 1 run team join 0 @a[scores={Lives=0}]
execute if score hcr_settings name_colors matches 1 run team join 1 @a[scores={Lives=1}]
execute if score hcr_settings name_colors matches 1 run team join 2 @a[scores={Lives=2}]
execute if score hcr_settings name_colors matches 1 run team join 3 @a[scores={Lives=3}]
execute if score hcr_settings name_colors matches 1 run team join 4 @a[scores={Lives=4..}]

tag @a add nHrCheck

# Defaults
execute unless score hcr_settings hcrDefaults matches 1 run scoreboard players set hcr_settings life_jam 1
execute unless score hcr_settings hcrDefaults matches 1 run scoreboard players set hcr_settings soul_charm_debuffs 1
execute unless score hcr_settings hcrDefaults matches 1 run scoreboard players set hcr_settings revive_debuffs 1
execute unless score hcr_settings hcrDefaults matches 1 run scoreboard players set hcr_settings name_colors 1
execute unless score hcr_settings hcrDefaults matches 1 run scoreboard players set hcr_settings custom_potions 1
scoreboard players set hcr_settings hcrDefaults 1
